function AddActor(name,fname,depth)
	local _depth = depth or "0"
	return ActorManager.GetInstance():AddActor(name,fname,_depth)
end

function AutoRelease(name)
	ActorManager.GetInstance():AutoRelease(name)
end

function SetItemImage(name,icon)
	ActorManager.GetInstance():SetItemImage(name,icon)
end

function SetPosition(name,x,y)
	ActorManager.GetInstance():SetPosition(name,x,y)
end

function SetScale(name,x,y)
	ActorManager.GetInstance():SetScale(name,x,y)
end

function SetRotation(name,z)
	ActorManager.GetInstance():SetRotation(name,z)
end

function SetActorActive(name,active)
	ActorManager.GetInstance():SetActorActive(name,active)
end

function MoveTo(name,eventname,x,y,animeID,speed,hasComplete)
	local _hasComplete = hasComplete or "false"
	ActorManager.GetInstance():MoveTo(name,eventname,x,y,animeID,speed,_hasComplete)
end

function ScaleTo(name,eventname,x,y,animeID,speed,hasComplete)
	local _hasComplete = hasComplete or "false"
	ActorManager.GetInstance():ScaleTo(name,eventname,x,y,animeID,speed,_hasComplete)
end

function RotateTo(name,eventname,z,speed,loop)
	local _loop = loop or "false"
	ActorManager.GetInstance():RotateTo(name,eventname,z,speed,_loop)
end

function JumpTo(name,eventname,x,y,h,animeID,speed,hasComplete)
	local _hasComplete = hasComplete or "false"
	ActorManager.GetInstance():JumpTo(name,eventname,x,y,h,animeID,speed,_hasComplete)
end

function FadeIn(name,eventname,speed,hasComplete)
	local _hasComplete = hasComplete or "false"
	ActorManager.GetInstance():FadeIn(name,eventname,speed,_hasComplete)
end

function FadeOut(name,eventname,speed,hasComplete)
	local _hasComplete = hasComplete or "false"
	ActorManager.GetInstance():FadeOut(name,eventname,speed,_hasComplete)
end

function PlayAnimation(name,animeID,loop)
	local _loop = loop or "false"
	ActorManager.GetInstance():PlayAnimation(name,animeID,_loop)
end

function SetAnimationSpeed(name,speed)
	ActorManager.GetInstance():SetAnimationSpeed(name,speed)
end

function PauseAnimation(name)
	ActorManager.GetInstance():PauseAnimation(name)
end

function ResumeAnimation(name)
	ActorManager.GetInstance():ResumeAnimation(name)
end

function SetDepth(name,depth)
	ActorManager.GetInstance():SetDepth(name,depth)
end

function GetPositionX(name)
	return ActorManager.GetInstance():GetPositionX(name)
end

function GetPositionY(name)
	return ActorManager.GetInstance():GetPositionY(name)
end

function DestroyAutoReleaseObj()
	ActorManager.GetInstance():DestroyAutoReleaseObj()
end

-- ここの[DestroyActor]は[EventUtils]にいる同名の関数により上書きされるので
-- 利用できないことを明確化するためにコメントアウトしておく
--function DestroyActor(name)
--	ActorManager.GetInstance():DestroyActor(name)
--end