function IsExeRandom(par)
	return GameSkillFunctions.GetInstance():IsExeRandom(par)
end

function IsMaxPlayerHP()
	return GameSkillFunctions.GetInstance():IsMaxPlayerHP()
end

function IsDeadPlayer()
	return GameSkillFunctions.GetInstance():IsDeadPlayer()
end

function IsExistBattleMonster()
	return GameSkillFunctions.GetInstance():IsExistBattleMonster()
end

function IsMaxBattleMonsterHP()
	return GameSkillFunctions.GetInstance():IsMaxBattleMonsterHP()
end

function GetBattleMonsterID()
	return GameSkillFunctions.GetInstance():GetBattleMonsterID()
end

function GetCurrentHP(caller)
	return GameSkillFunctions.GetInstance():GetCurrentHP(caller)
end

function GetCurrentHPPercent(caller)
	return GameSkillFunctions.GetInstance():GetCurrentHPPercent(caller)
end

function IsExistMonster(includeInvisibleMonster)
	local _includeInvisibleMonster = includeInvisibleMonster or false
	return GameSkillFunctions.GetInstance():IsExistMonster(_includeInvisibleMonster)
end

function HasSkillTag(target,tag)
	return GameSkillFunctions.GetInstance():HasSkillTag(target,tag)
end

function IsExistTargetNextTile(target)
	return GameSkillFunctions.GetInstance():IsExistTargetNextTile(target)
end

function IsExistTargetFront(range,includeInvisible,isPerforate)
	local _includeInvisible = includeInvisible or false
	local _isPerforate = isPerforate or false
	return GameSkillFunctions.GetInstance():IsExistTargetFront(range,_includeInvisible,_isPerforate)
end

function IsExistTargetDirection(caller,target,direction,range,isCheckWall)
	local _isCheckWall = isCheckWall or false
	return GameSkillFunctions.GetInstance():IsExistTargetDirection(caller,target,direction,range,_isCheckWall)
end

function IsExistTargetRow(caller,target,range,isCheckWall)
	local _isCheckWall = isCheckWall or false
	return GameSkillFunctions.GetInstance():IsExistTargetRow(caller,target,range,_isCheckWall)
end

function IsExistTargetColumn(caller,target,range,isCheckWall)
	local _isCheckWall = isCheckWall or false
	return GameSkillFunctions.GetInstance():IsExistTargetColumn(caller,target,range,_isCheckWall)
end

function IsExistTargetCross(caller,target,range,isCheckWall)
	local _isCheckWall = isCheckWall or false
	return GameSkillFunctions.GetInstance():IsExistTargetCross(caller,target,range,_isCheckWall)
end

function IsExistTargetSautoir(caller,target,range)
	return GameSkillFunctions.GetInstance():IsExistTargetSautoir(caller,target,range)
end

function IsExistTargetBox(caller,target,width,height,tag,isPerforate,includeInvisible)
	local _height = height or 0
	local _tag = tag or nil
	local _isPerforate = isPerforate or true
	local _includeInvisible = includeInvisible or false
	return GameSkillFunctions.GetInstance():IsExistTargetBox(caller,target,width,_height,_tag,_isPerforate,_includeInvisible)
end

function IsExistMonsterRoute(range)
	return GameSkillFunctions.GetInstance():IsExistMonsterRoute(range)
end

function IsReflectionSkill(caller)
	return GameSkillFunctions.GetInstance():IsReflectionSkill(caller)
end

function IsExistWall()
	return GameSkillFunctions.GetInstance():IsExistWall()
end

function IsEnabledSetEscapeDoor(range)
	return GameSkillFunctions.GetInstance():IsEnabledSetEscapeDoor(range)
end

function IsLastFloor()
	return GameSkillFunctions.GetInstance():IsLastFloor()
end

function IsExistEnabledPullObject()
	return GameSkillFunctions.GetInstance():IsExistEnabledPullObject()
end

function IsPlayerGoal()
	return GameSkillFunctions.GetInstance():IsPlayerGoal()
end

function IsEnableKnockBack(caller)
	return GameSkillFunctions.GetInstance():IsEnableKnockBack(caller)
end

function IsReflection(caller,target)
	return GameSkillFunctions.GetInstance():IsReflection(caller,target)
end

function IsExistEnableMetamorphosisMonster(target)
	return GameSkillFunctions.GetInstance():IsExistEnableMetamorphosisMonster(target)
end

function SearchMetamorphosisMonsterID(target,isFloorMonsterID)
	local _isFloorMonsterID = isFloorMonsterID or false
	return GameSkillFunctions.GetInstance():SearchMetamorphosisMonsterID(target,_isFloorMonsterID)
end

function IsEnableAttackTarget(caller,target)
	return GameSkillFunctions.GetInstance():IsEnableAttackTarget(caller,target)
end

function GetTrapElapsedTurnCount(target)
	return GameSkillFunctions.GetInstance():GetTrapElapsedTurnCount(target)
end

function IsEnableMoveToTarget(caller,target)
	return GameSkillFunctions.GetInstance():IsEnableMoveToTarget(caller,target)
end

function IsExistEnabledGiveOilMonster(caller)
	return GameSkillFunctions.GetInstance():IsExistEnabledGiveOilMonster(caller)
end

function CalculateEnabledGiveOilMonsterID(caller)
	return GameSkillFunctions.GetInstance():CalculateEnabledGiveOilMonsterID(caller)
end

function IsExistTrap()
	return GameSkillFunctions.GetInstance():IsExistTrap()
end

function IsExistFloorEmptyTile(isCheckWater)
	local _isCheckWater = isCheckWater or false
	return GameSkillFunctions.GetInstance():IsExistFloorEmptyTile(_isCheckWater)
end

function IsExistAroundEmptyTile(target,isCheckWall,isCheckWater)
	local _isCheckWall = isCheckWall or false
	local _isCheckWater = isCheckWater or true
	return GameSkillFunctions.GetInstance():IsExistAroundEmptyTile(target,_isCheckWall,_isCheckWater)
end

function IsExistSubTypeTile(subTypeName)
	return GameSkillFunctions.GetInstance():IsExistSubTypeTile(subTypeName)
end

function CalculatePlayerAttackDirection(r,width,height,isPerforate)
	local _width = width or 1
	local _height = height or 1
	local _isPerforate = isPerforate or false
	return GameSkillFunctions.GetInstance():CalculatePlayerAttackDirection(r,_width,_height,_isPerforate)
end

function CalculatePlayerAttackRange(r,width,height)
	local _width = width or 1
	local _height = height or 1
	return GameSkillFunctions.GetInstance():CalculatePlayerAttackRange(r,_width,_height)
end

function CalculateAttackRange(caller,target,r,width,height)
	local _width = width or 1
	local _height = height or 1
	return GameSkillFunctions.GetInstance():CalculateAttackRange(caller,target,r,_width,_height)
end

function CalculateCloseToTarget(caller,includeInvisibleMonster,ignoreObstacle)
	local _includeInvisibleMonster = includeInvisibleMonster or false
	local _ignoreObstacle = ignoreObstacle or false
	return GameSkillFunctions.GetInstance():CalculateCloseToTarget(caller,_includeInvisibleMonster,_ignoreObstacle)
end

function CalculateFrontTarget(range,includeInvisible,isPerforate)
	local _includeInvisible = includeInvisible or false
	local _isPerforate = isPerforate or false
	return GameSkillFunctions.GetInstance():CalculateFrontTarget(range,_includeInvisible,_isPerforate)
end

function IsContainMonsterType(target,typeString)
	return GameSkillFunctions.GetInstance():IsContainMonsterType(target,typeString)
end

function IsChargePlayerState()
	return GameSkillFunctions.GetInstance():IsChargePlayerState()
end

function IsDarknessFloor()
	return GameSkillFunctions.GetInstance():IsDarknessFloor()
end

function IsLampRange(target)
	return GameSkillFunctions.GetInstance():IsLampRange(target)
end

function HasPlayerItem(containsInfiniteItem)
	local _containsInfiniteItem = containsInfiniteItem or false
	return GameSkillFunctions.GetInstance():HasPlayerItem(_containsInfiniteItem)
end

function HasPlayerGold(gold)
	local _gold = gold or 0
	return GameSkillFunctions.GetInstance():HasPlayerGold(_gold)
end

function HasDropItem(target)
	return GameSkillFunctions.GetInstance():HasDropItem(target)
end

function GetSkillCounter(target)
	return GameSkillFunctions.GetInstance():GetSkillCounter(target)
end

function GetSkillCounterText(target,baseCount)
	local _baseCount = baseCount or 0
	return GameSkillFunctions.GetInstance():GetSkillCounterText(target,_baseCount)
end

function AddSkillCounter(target)
	GameSkillFunctions.GetInstance():AddSkillCounter(target)
end

function ResetSkillCounter(target)
	GameSkillFunctions.GetInstance():ResetSkillCounter(target)
end

function IsExistBoss()
	return GameSkillFunctions.GetInstance():IsExistBoss()
end

function IsWarpFloor()
	return GameSkillFunctions.GetInstance():IsWarpFloor()
end

function IsExistEmptyTile(target)
	return GameSkillFunctions.GetInstance():IsExistEmptyTile(target)
end

function GetStatusDiff(caller,target,parameterKey,correctionValue,minValue,maxValue)
	local _correctionValue = correctionValue or 0
	local _minValue = minValue or 0
	local _maxValue = maxValue or 999
	return GameSkillFunctions.GetInstance():GetStatusDiff(caller,target,parameterKey,_correctionValue,_minValue,_maxValue)
end

function GetIndexRow(target)
	return GameSkillFunctions.GetInstance():GetIndexRow(target)
end

function GetIndexColumn(target)
	return GameSkillFunctions.GetInstance():GetIndexColumn(target)
end

function GetBattleInfoSkillID(target)
	return GameSkillFunctions.GetInstance():GetBattleInfoSkillID(target)
end

function GetBattleInfoItemID(target)
	return GameSkillFunctions.GetInstance():GetBattleInfoItemID(target)
end

function GetBattleInfoSkillType(target)
	return GameSkillFunctions.GetInstance():GetBattleInfoSkillType(target)
end

function GetBattleInfoSkillAttribute(target)
	return GameSkillFunctions.GetInstance():GetBattleInfoSkillAttribute(target)
end

function GetBattleInfoSkillElement(target)
	return GameSkillFunctions.GetInstance():GetBattleInfoSkillElement(target)
end

function GetBattleInfoActionType(target)
	return GameSkillFunctions.GetInstance():GetBattleInfoActionType(target)
end

function IsContainBattleInfoTarget(target,monsterID,fuzzySearch)
	local _fuzzySearch = fuzzySearch or false
	return GameSkillFunctions.GetInstance():IsContainBattleInfoTarget(target,monsterID,_fuzzySearch)
end

function IsContainBattleInfoTargetWithFloorMonsterID(target,floorMonsterID)
	return GameSkillFunctions.GetInstance():IsContainBattleInfoTargetWithFloorMonsterID(target,floorMonsterID)
end

function GetBattleInfoSkillHistory(target,skillID)
	return GameSkillFunctions.GetInstance():GetBattleInfoSkillHistory(target,skillID)
end

function ClearBattleInfoSkillHistory(target)
	GameSkillFunctions.GetInstance():ClearBattleInfoSkillHistory(target)
end

function HasItem(itemID)
	return GameSkillFunctions.GetInstance():HasItem(itemID)
end

function HasMagicItem()
	return GameSkillFunctions.GetInstance():HasMagicItem()
end

function IsContainMetamorphosisEscapeMonsterList(monsterID)
	return GameSkillFunctions.GetInstance():IsContainMetamorphosisEscapeMonsterList(monsterID)
end

function GetTargetFloorMonsterID(target)
	return GameSkillFunctions.GetInstance():GetTargetFloorMonsterID(target)
end

function GetTargetStatus(target,key)
	return GameSkillFunctions.GetInstance():GetTargetStatus(target,key)
end

function SetForceExecuteActiveSkillName(skillName)
	GameSkillFunctions.GetInstance():SetForceExecuteActiveSkillName(skillName)
end

function HasPhaseChangeCount(phaseName)
	return GameSkillFunctions.GetInstance():HasPhaseChangeCount(phaseName)
end

function HasPhaseChangeMonsterID(phaseName)
	return GameSkillFunctions.GetInstance():HasPhaseChangeMonsterID(phaseName)
end

function GetMonsterName(monsterID)
	return GameSkillFunctions.GetInstance():GetMonsterName(monsterID)
end

function GetTargetName(target)
	return GameSkillFunctions.GetInstance():GetTargetName(target)
end

function GetDamageInfoValue(target)
	return GameSkillFunctions.GetInstance():GetDamageInfoValue(target)
end

function GetDamageInfoAttribute(target)
	return GameSkillFunctions.GetInstance():GetDamageInfoAttribute(target)
end

function GetDamageInfoElement(target)
	return GameSkillFunctions.GetInstance():GetDamageInfoElement(target)
end

function GetDamageInfoDirection(target)
	return GameSkillFunctions.GetInstance():GetDamageInfoDirection(target)
end

function GetDamageInfoRange(target)
	return GameSkillFunctions.GetInstance():GetDamageInfoRange(target)
end

function GetIdleAnimationName(target)
	return GameSkillFunctions.GetInstance():GetIdleAnimationName(target)
end

function IsOpenPitfall()
	return GameSkillFunctions.GetInstance():IsOpenPitfall()
end

function GetDropInfoValue(target)
	return GameSkillFunctions.GetInstance():GetDropInfoValue(target)
end

function GetSubType(target)
	return GameSkillFunctions.GetInstance():GetSubType(target)
end

function IsMimicry(target)
	return GameSkillFunctions.GetInstance():IsMimicry(target)
end

function FindMonsterID(findID)
	return GameSkillFunctions.GetInstance():FindMonsterID(findID)
end

function GetFloorMonsterID(findID)
	return GameSkillFunctions.GetInstance():GetFloorMonsterID(findID)
end

function PlaySingleAnim(target,animName,range,directionString,isForce)
	local _range = range or nil
	local _directionString = directionString or nil
	local _isForce = isForce or false
	GameSkillFunctions.GetInstance():PlaySingleAnim(target,animName,_range,_directionString,_isForce)
end

function SetTargetAnimationSpeed(target,speed)
	GameSkillFunctions.GetInstance():SetTargetAnimationSpeed(target,speed)
end

function ResetTargetAnimationSpeed(target)
	GameSkillFunctions.GetInstance():ResetTargetAnimationSpeed(target)
end

function PlayDefaultAnim(target)
	GameSkillFunctions.GetInstance():PlayDefaultAnim(target)
end

function PlayPrevAnim(target)
	GameSkillFunctions.GetInstance():PlayPrevAnim(target)
end

function PlaySingleTargetEffect(target,prefName,animName,range,layer,targetTypeString,caller,reuseFlyEffectTarget)
	local _range = range or nil
	local _layer = layer or "Top"
	local _targetTypeString = targetTypeString or "All"
	local _caller = caller or nil
	local _reuseFlyEffectTarget = reuseFlyEffectTarget or nil
	GameSkillFunctions.GetInstance():PlaySingleTargetEffect(target,prefName,animName,_range,_layer,_targetTypeString,_caller,_reuseFlyEffectTarget)
end

function PlayEffectWithMonsterID(mID,prefName,animName,layer,targetTypeString,caller)
	local _layer = layer or "Top"
	local _targetTypeString = targetTypeString or "All"
	local _caller = caller or nil
	GameSkillFunctions.GetInstance():PlayEffectWithMonsterID(mID,prefName,animName,_layer,_targetTypeString,_caller)
end

function PlayRangeEffect(caller,prefName,animName,range,layer,wait,effectSEName)
	local _range = range or nil
	local _layer = layer or "Top"
	local _wait = wait or 0.0
	local _effectSEName = effectSEName or nil
	GameSkillFunctions.GetInstance():PlayRangeEffect(caller,prefName,animName,_range,_layer,_wait,_effectSEName)
end

function PlayEffect(prefName,animName,x,y,direction)
	local _x = x or 0
	local _y = y or 0
	local _direction = direction or nil
	GameSkillFunctions.GetInstance():PlayEffect(prefName,animName,_x,_y,_direction)
end

function PlayAttackAnimation(caller,target,name,isLoop)
	local _isLoop = isLoop or false
	GameSkillFunctions.GetInstance():PlayAttackAnimation(caller,target,name,_isLoop)
end

function PlayUseItemIconAnimation(caller)
	GameSkillFunctions.GetInstance():PlayUseItemIconAnimation(caller)
end

function PlayShakeMapAnimation(x,y,time)
	GameSkillFunctions.GetInstance():PlayShakeMapAnimation(x,y,time)
end

function ShowTrap(target,animation)
	local _animation  = animation or false
	GameSkillFunctions.GetInstance():ShowTrap(target,_animation)
end

function PlayTrapAnimation(target,name,playEndHide)
	local _playEndHide  = playEndHide or false
	GameSkillFunctions.GetInstance():PlayTrapAnimation(target,name,_playEndHide)
end

function AddParticle(target,name)
	GameSkillFunctions.GetInstance():AddParticle(target,name)
end

function RemoveParticle(target,delay)
	local _delay  = delay or 0.0
	GameSkillFunctions.GetInstance():RemoveParticle(target,_delay)
end

function PlayMoveToAnimation(caller,target,type,time)
	GameSkillFunctions.GetInstance():PlayMoveToAnimation(caller,target,type,time)
end

function PlayMoveToCurrentPositionAnimation(target,x,y,time,type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayMoveToCurrentPositionAnimation(target,x,y,time,_type)
end

function CreatePrefabObject(path,time,target,direction,useUICamera,range,ignoreObstacle)
	local _target = target or nil
	local _direction = direction or nil
	local _useUICamera = useUICamera or false
	local _range = range or nil
	local _ignoreObstacle = ignoreObstacle or false
	GameSkillFunctions.GetInstance():CreatePrefabObject(path,time,_target,_direction,_useUICamera,_range,_ignoreObstacle)
end

function PlayMoveToEffectAnimation(caller,target,prefName,animName,time,delay,darknessCircleRange,removeDelayCircleTime,easeType)
	local _time = time or 0.0
	local _delay = delay or 0.0
	local _darknessCircleRange = darknessCircleRange or 0.0
	local _removeDelayCircleTime = removeDelayCircleTime or 0.0
	local _easeType = easeType or "easeInCubic"
	GameSkillFunctions.GetInstance():PlayMoveToEffectAnimation(caller,target,prefName,animName,_time,_delay,_darknessCircleRange,_removeDelayCircleTime,_easeType)
end

function SetActiveDarknessCircle(active)
	GameSkillFunctions.GetInstance():SetActiveDarknessCircle(active)
end

function SetIdleAnimation(target,animName)
	GameSkillFunctions.GetInstance():SetIdleAnimation(target,animName)
end

function PlayRollAnimation(caller,target,count,time,radius)
	GameSkillFunctions.GetInstance():PlayRollAnimation(caller,target,count,time,radius)
end

function CreateDarknessOverlayObject(target,prefName,isPlayStartAnim,animPositionX,animPositionY,animScale,animTime)
	local _isPlayStartAnim = isPlayStartAnim or false
	local _animPositionX = animPositionX or 0.0
	local _animPositionY = animPositionY or 0.0
	local _animScale = animScale or 0.0
	local _animTime = animTime or 0.0
	GameSkillFunctions.GetInstance():CreateDarknessOverlayObject(target,prefName,_isPlayStartAnim,_animPositionX,_animPositionY,_animScale,_animTime)
end

function RemoveDarknessOverlayObject(target,isPlayStartAnim,animPositionX,animPositionY,animScale,animTime)
	local _isPlayStartAnim = isPlayStartAnim or false
	local _animPositionX = animPositionX or 0.0
	local _animPositionY = animPositionY or 0.0
	local _animScale = animScale or 0.0
	local _animTime = animTime or 0.0
	GameSkillFunctions.GetInstance():RemoveDarknessOverlayObject(target,_isPlayStartAnim,_animPositionX,_animPositionY,_animScale,_animTime)
end

function SetActiveSprite(target,active)
	GameSkillFunctions.GetInstance():SetActiveSprite(target,active)
end

function LoadWarpEffect()
	GameSkillFunctions.GetInstance():LoadWarpEffect()
end

function PlayCuttingScreenAnimation(top,bottom,animationTime,waitTime)
	GameSkillFunctions.GetInstance():PlayCuttingScreenAnimation(top,bottom,animationTime,waitTime)
end

function LoadCuttingScreenEffect()
	GameSkillFunctions.GetInstance():LoadCuttingScreenEffect()
end

function PlayOverlayAnimation(r,g,b,animationTime,waitTime)
	GameSkillFunctions.GetInstance():PlayOverlayAnimation(r,g,b,animationTime,waitTime)
end

function PlayTransformAnimation(target)
	GameSkillFunctions.GetInstance():PlayTransformAnimation(target)
end

function SetActiveMonsterUI(target,isActive)
	GameSkillFunctions.GetInstance():SetActiveMonsterUI(target,isActive)
end

function PlayStartTrickTripEffect(animationTime,startFadeInTime)
	GameSkillFunctions.GetInstance():PlayStartTrickTripEffect(animationTime,startFadeInTime)
end

function PlayFinishTrickTripEffect(animationTime,fadeOutTime)
	GameSkillFunctions.GetInstance():PlayFinishTrickTripEffect(animationTime,fadeOutTime)
end

function PlayRemoveFloorEffect()
	GameSkillFunctions.GetInstance():PlayRemoveFloorEffect()
end

function UpdateMoveToBossStartPosition(target)
	GameSkillFunctions.GetInstance():UpdateMoveToBossStartPosition(target)
end

function PlayMoveToBossEffect(target,moveTime)
	GameSkillFunctions.GetInstance():PlayMoveToBossEffect(target,moveTime)
end

function SetActiveGoalDoor(isActive)
	GameSkillFunctions.GetInstance():SetActiveGoalDoor(isActive)
end

function SetActiveStartDoorText(isActive)
	GameSkillFunctions.GetInstance():SetActiveStartDoorText(isActive)
end

function SetActiveGoalDoorText(isActive)
	GameSkillFunctions.GetInstance():SetActiveGoalDoorText(isActive)
end

function PlayStartDoorAnimation(animName)
	GameSkillFunctions.GetInstance():PlayStartDoorAnimation(animName)
end

function GoalStartDoorAnimation(animName)
	GameSkillFunctions.GetInstance():GoalStartDoorAnimation(animName)
end

function PlayEvent(eventName)
	GameSkillFunctions.GetInstance():PlayEvent(eventName)
end

function PlayDungeonFadeInAnimation(time,r,g,b)
	local _r = r or 1.0
	local _g = g or 1.0
	local _b = b or 1.0
	GameSkillFunctions.GetInstance():PlayDungeonFadeInAnimation(time,_r,_g,_b)
end

function PlayDungeonFadeOutAnimation(time,r,g,b)
	local _r = r or 1.0
	local _g = g or 1.0
	local _b = b or 1.0
	GameSkillFunctions.GetInstance():PlayDungeonFadeOutAnimation(time,_r,_g,_b)
end

function PlayDungeonRasterScrollInAnimation(animationTime)
	local _animationTime = animationTime or 3.0
	GameSkillFunctions.GetInstance():PlayDungeonRasterScrollInAnimation(_animationTime)
end

function PlayDungeonRasterScrollOutAnimation(animationTime)
	local _animationTime = animationTime or 3.0
	GameSkillFunctions.GetInstance():PlayDungeonRasterScrollOutAnimation(_animationTime)
end

function ShowAllTreasureContents()
	GameSkillFunctions.GetInstance():ShowAllTreasureContents()
end

function HideAllTreasureContents()
	GameSkillFunctions.GetInstance():HideAllTreasureContents()
end

function PlayFallAnimation(target,time)
	GameSkillFunctions.GetInstance():PlayFallAnimation(target,time)
end

function PlayFlash()
	GameSkillFunctions.GetInstance():PlayFlash()
end

function HideAllHPBar(delay)
	local _delay = delay or 0.0
	GameSkillFunctions.GetInstance():HideAllHPBar(_delay)
end

function PlayDarknessCircleAnimation(time,wait,range)
	GameSkillFunctions.GetInstance():PlayDarknessCircleAnimation(time,wait,range)
end

function SetBattleIdleAnim(target)
	GameSkillFunctions.GetInstance():SetBattleIdleAnim(target)
end

function PlayBossExpandAnimation(monsterID, time)
	local _time = time or 0.0
	return GameSkillFunctions.GetInstance():PlayBossExpandAnimation(monsterID, _time)
end

function PlayBossMonsterFadeAnimation(monsterID,animName,count,time)
	GameSkillFunctions.GetInstance():PlayBossMonsterFadeAnimation(monsterID,animName,count,time)
end

function PlaySkillStartAnimation(caller,animName,isUseItem,useSEName)
	local _useSEName = useSEName or ""
	GameSkillFunctions.GetInstance():PlaySkillStartAnimation(caller,animName,isUseItem,_useSEName)
end

function PlaySpellEffect(target,time)
	GameSkillFunctions.GetInstance():PlaySpellEffect(target,time)
end

function ExeAttack(caller,target,range,attackAnimName,hitEffectName,skillDamage,flyEffectName,flyEffectSpeed,attachEffectName,isSkipCriticalAnim)
	local _range = range or nil
	local _attackAnimName = attackAnimName or nil
	local _hitEffectName = hitEffectName or nil
	local _skillDamage = skillDamage or 0
	local _flyEffectName = flyEffectName or nil
	local _flyEffectSpeed = flyEffectSpeed or 0.0
	local _attachEffectName = attachEffectName or nil
	local _isSkipCriticalAnim = isSkipCriticalAnim or false
	GameSkillFunctions.GetInstance():ExeAttack(caller,target,_range,_attackAnimName,_hitEffectName,_skillDamage,_flyEffectName,_flyEffectSpeed,_attachEffectName,_isSkipCriticalAnim)
end

function ExeLineAttack(caller,target,attackAnimName,prefName,animName,isCalculateEndPosition,skillDamage,time,isRoundTrip,roundTripDelay,seName)
	local _isCalculateEndPosition = isCalculateEndPosition or false
	local _skillDamage = skillDamage or 0
	local _time = time or 0.0
	local _isRoundTrip = isRoundTrip or false
	local _roundTripDelay = roundTripDelay or 0.0
	local _seName = seName or nil
	GameSkillFunctions.GetInstance():ExeLineAttack(caller,target,attackAnimName,prefName,animName,_isCalculateEndPosition,_skillDamage,_time,_isRoundTrip,_roundTripDelay,_seName)
end

function ExeSkipAnimationAttack(caller,target,range,hitEffectName,skillDamage,flyEffectName,flyEffectSpeed)
	local _range = range or nil
	local _hitEffectName = hitEffectName or nil
	local _skillDamage = skillDamage or 0
	local _flyEffectName = flyEffectName or nil
	local _flyEffectSpeed = flyEffectSpeed or 0.0
	GameSkillFunctions.GetInstance():ExeSkipAnimationAttack(caller,target,_range,_hitEffectName,_skillDamage,_flyEffectName,_flyEffectSpeed)
end

function ExeSkipAnimationAttackForNearbyTarget(caller,target,direction,range,hitEffectName,skillDamage,flyEffectName,flyEffectSpeed)
	local _range = range or nil
	local _hitEffectName = hitEffectName or nil
	local _skillDamage = skillDamage or 0
	local _flyEffectName = flyEffectName or nil
	local _flyEffectSpeed = flyEffectSpeed or 0.0
	GameSkillFunctions.GetInstance():ExeSkipAnimationAttackForNearbyTarget(caller,target,direction,_range,_hitEffectName,_skillDamage,_flyEffectName,_flyEffectSpeed)
end

function HealHP(caller,target,heal,time,range)
	local _heal = heal or 0
	local _time = time or 0.5
	local _range = range or nil
	GameSkillFunctions.GetInstance():HealHP(caller,target,_heal,_time,_range)
end

function HealHPReferenceTargetDamage(caller,target,min,max,time,range)
	local _range = range or ""
	GameSkillFunctions.GetInstance():HealHPReferenceTargetDamage(caller,target,min,max,time,_range)
end

function SetHPMax(target)
	GameSkillFunctions.GetInstance():SetHPMax(target)
end

function GetAttackResult(target)
	return GameSkillFunctions.GetInstance():GetAttackResult(target)
end

function SetPassiveHitSkillResult (target,result)
	GameSkillFunctions.GetInstance():SetPassiveHitSkillResult (target,result)
end

function SetPassiveHitSkillDamageRate (target,rate)
	GameSkillFunctions.GetInstance():SetPassiveHitSkillDamageRate (target,rate)
end

function SetPassiveHitSkillDamageAnimName (target,animName)
	GameSkillFunctions.GetInstance():SetPassiveHitSkillDamageAnimName (target,animName)
end

function IsEnabledReserveCountdownAction(target)
	return GameSkillFunctions.GetInstance():IsEnabledReserveCountdownAction(target)
end

function GetCountdownActionName(target)
	return GameSkillFunctions.GetInstance():GetCountdownActionName(target)
end

function SetCountdownAction(target,skillName,skillTurn)
	GameSkillFunctions.GetInstance():SetCountdownAction(target,skillName,skillTurn)
end

function ResetCountdownAction(target)
	GameSkillFunctions.GetInstance():ResetCountdownAction(target)
end

function CreateMonster(monsterID,row,col,isCheckSubType)
	local _isCheckSubType = isCheckSubType or false
	return GameSkillFunctions.GetInstance():CreateMonster(monsterID,row,col,_isCheckSubType)
end

function CreateMonsterFromGroupID(groupID,row,col,isCheckSubType)
	local _isCheckSubType = isCheckSubType or false
	return GameSkillFunctions.GetInstance():CreateMonsterFromGroupID(groupID,row,col,_isCheckSubType)
end

function RemoveMonster(mID)
	GameSkillFunctions.GetInstance():RemoveMonster(mID)
end

function ChangeMonster(currentFloorMonsterID,monsterID)
	return GameSkillFunctions.GetInstance():ChangeMonster(currentFloorMonsterID,monsterID)
end

function ChangeMonsterFromGroupID(currentFloorMonsterID,groupID,isCheckEnableChange,isCheckReflection,caller)
	local _isCheckEnableChange = isCheckEnableChange or false
	local _isCheckReflection = isCheckReflection or false
	local _caller = caller or nil
	return GameSkillFunctions.GetInstance():ChangeMonsterFromGroupID(currentFloorMonsterID,groupID,_isCheckEnableChange,_isCheckReflection,_caller)
end

function SetActiveMonster(mID,isActive)
	GameSkillFunctions.GetInstance():SetActiveMonster(mID,isActive)
end

function CreateMonsterAroundEmptyTile(target,monsterID,animation,time,height,useMonsterGroup,isCheckWater)
	local _useMonsterGroup = useMonsterGroup or false
	local _isCheckWater = isCheckWater or true
	return GameSkillFunctions.GetInstance():CreateMonsterAroundEmptyTile(target,monsterID,animation,time,height,_useMonsterGroup,_isCheckWater)
end

function CreateMonsterNearestEmptyTile(target,monsterID,animation,animationTime,removeEffectTime,direction,effectName,useMonsterGroup,battleIdleAnim)
	local _useMonsterGroup = useMonsterGroup or false
	local _battleIdleAnim = battleIdleAnim or false
	return GameSkillFunctions.GetInstance():CreateMonsterNearestEmptyTile(target, monsterID, animation, animationTime,removeEffectTime,direction,effectName,_useMonsterGroup,_battleIdleAnim)
end

function UpdateMonsterLevel(mID,level)
	GameSkillFunctions.GetInstance():UpdateMonsterLevel(mID,level)
end

function AddPhaseChange(caller,target,phaseName,range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():AddPhaseChange(caller,target,phaseName,_range)
end

function AddPhaseChangeWithTurn(caller,target,phaseName,range,turn)
	GameSkillFunctions.GetInstance():AddPhaseChangeWithTurn(caller,target,phaseName,range,turn)
end

function AddPhaseChangeWithValue(caller,target,phaseName,range,turn,value,valueBlur)
	GameSkillFunctions.GetInstance():AddPhaseChangeWithValue(caller,target,phaseName,range,turn,value,valueBlur)
end

function AddCustomPhaseChange(caller,target,phaseName,range,turn,value,valueBlur,probability,isPermanence,recovery)
	GameSkillFunctions.GetInstance():AddCustomPhaseChange(caller,target,phaseName,range,turn,value,valueBlur,probability,isPermanence,recovery)
end

function AddPhaseChangeWithRate(successRate,caller,target,phaseName,range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():AddPhaseChangeWithRate(successRate,caller,target,phaseName,_range)
end

function AddPhaseChangeWithRateAndTurn(successRate,caller,target,phaseName,range,turn)
	GameSkillFunctions.GetInstance():AddPhaseChangeWithRateAndTurn(successRate,caller,target,phaseName,range,turn)
end

function AddPhaseChangeWithRateAndValue(successRate,caller,target,phaseName,range,turn,value,valueBlur)
	GameSkillFunctions.GetInstance():AddPhaseChangeWithRateAndValue(successRate,caller,target,phaseName,range,turn,value,valueBlur)
end

function AddCustomPhaseChangeWithRate(successRate,caller,target,phaseName,range,turn,value,valueBlur,probability,isPermanence,recovery)
	GameSkillFunctions.GetInstance():AddCustomPhaseChangeWithRate(successRate,caller,target,phaseName,range,turn,value,valueBlur,probability,isPermanence,recovery)
end

function AddPermanencePhaseChange(caller,target,phaseName,range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():AddPermanencePhaseChange(caller,target,phaseName,_range)
end

function AddCustomPermanencePhaseChange(caller,target,phaseName,range,value,valueBlur,probability)
	GameSkillFunctions.GetInstance():AddCustomPermanencePhaseChange(caller,target,phaseName,range,value,valueBlur,probability)
end

function AddParam(caller,target,h,at,df,spd,ht,l,gd,turn,name,isPar,mgc)
	local _name = name or nil
	local _isPar = isPar or false
	local _mgc = mgc or 0
	GameSkillFunctions.GetInstance():AddParam(caller,target,h,at,df,spd,ht,l,gd,turn,_name,_isPar,_mgc)
end

function AddLuckParam(caller,target,param,turn,name,isPar)
	local _name = name or nil
	local _isPar = isPar or false
	GameSkillFunctions.GetInstance():AddLuckParam(caller,target,param,turn,_name,_isPar)
end

function AddGuardParam(caller,target,param,turn,name,isPar)
	local _name = name or nil
	local _isPar = isPar or false
	GameSkillFunctions.GetInstance():AddGuardParam(caller,target,param,turn,_name,_isPar)
end

function AddMagicParam(caller,target,param,turn,isPar,name)
	local _name = name or nil
	local _isPar = isPar or false
	GameSkillFunctions.GetInstance():AddMagicParam(caller,target,param,turn,_isPar,_name)
end

function RemovePhaseChange(target,name,range,includeInvisible,caller,skillID)
	local _range = range or nil
	local _includeInvisible = includeInvisible or false
	local _caller = caller or nil
	local _skillID = skillID or nil
	GameSkillFunctions.GetInstance():RemovePhaseChange(target,name,_range,_includeInvisible,_caller,_skillID)
end

function RemoveAllBadPhaseChange(target,range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():RemoveAllBadPhaseChange(target,_range)
end

function HasPhaseChange(target,name,isContainPermanence,skillID)
	local _isContainPermanence = isContainPermanence or false
	local _skillID = skillID or nil
	return GameSkillFunctions.GetInstance():HasPhaseChange(target,name,_isContainPermanence,_skillID)
end

function HasBadPhaseChange(target)
	return GameSkillFunctions.GetInstance():HasBadPhaseChange(target)
end

function HasPhaseChangeFloorMonsters(name)
	return GameSkillFunctions.GetInstance():HasPhaseChangeFloorMonsters(name)
end

function AddOilWithAnimation(caller,type,time)
	GameSkillFunctions.GetInstance():AddOilWithAnimation(caller,type,time)
end

function AddAttachInvalidPhaseChanges(target,phaseChange)
	GameSkillFunctions.GetInstance():AddAttachInvalidPhaseChanges(target,phaseChange)
end

function HasAttachInvalidPhaseChanges(target,phaseChange)
	return GameSkillFunctions.GetInstance():HasAttachInvalidPhaseChanges(target,phaseChange)
end

function AddWeakElements(target,elements)
	GameSkillFunctions.GetInstance():AddWeakElements(target,elements)
end

function AddHalfElements(target,elements)
	GameSkillFunctions.GetInstance():AddHalfElements(target,elements)
end

function AddInvalidElements(target,elements)
	GameSkillFunctions.GetInstance():AddInvalidElements(target,elements)
end

function AddNormalAttackTag(target,tags)
	GameSkillFunctions.GetInstance():AddNormalAttackTag(target,tags)
end

function AddNormalAttackElements(target,elements)
	GameSkillFunctions.GetInstance():AddNormalAttackElements(target,elements)
end

function PlaySingleSE(name)
	GameSkillFunctions.GetInstance():PlaySingleSE(name)
end

function PauseLoopSE()
	GameSkillFunctions.GetInstance():PauseLoopSE()
end

function ResumeLoopSE()
	GameSkillFunctions.GetInstance():ResumeLoopSE()
end

function PlayVoice(caller,name)
	GameSkillFunctions.GetInstance():PlayVoice(caller,name)
end

function PlayCurrentFloorBGM()
	GameSkillFunctions.GetInstance():PlayCurrentFloorBGM()
end

function RemoveWall(row,col,direction,skipEffectAnim)
	local _skipEffectAnim = skipEffectAnim or false
	GameSkillFunctions.GetInstance():RemoveWall(row,col,direction,_skipEffectAnim)
end

function RemoveWallAll(skipEffectAnim)
	local _skipEffectAnim = skipEffectAnim or false
	GameSkillFunctions.GetInstance():RemoveWallAll(_skipEffectAnim)
end

function CreateEscapeDoor(range,prefName,animName,createInterval,openInterval)
	local _createInterval = createInterval or 0
	local _openInterval = openInterval or 0
	GameSkillFunctions.GetInstance():CreateEscapeDoor(range,prefName,animName,_createInterval,_openInterval)
end

function PullFloorObjects(moveTime)
	GameSkillFunctions.GetInstance():PullFloorObjects(moveTime)
end

function EscapeMonster(target,time,jumpHeight)
	GameSkillFunctions.GetInstance():EscapeMonster(target,time,jumpHeight)
end

function MoveToTarget(caller,target)
	GameSkillFunctions.GetInstance():MoveToTarget(caller,target)
end

function RemoveAllTrap(defaultRatCount,moveTime,delayTime)
	GameSkillFunctions.GetInstance():RemoveAllTrap(defaultRatCount,moveTime,delayTime)
end

function MoveToEmptyTile(target,outAnimName,inAnimName,interval,isCheckWater)
	local _isCheckWater = isCheckWater or false
	GameSkillFunctions.GetInstance():MoveToEmptyTile(target,outAnimName,inAnimName,interval,_isCheckWater)
end

function MoveToAroundEmptyTile(target,time,isRotate)
	local _isRotate = isRotate or false
	GameSkillFunctions.GetInstance():MoveToAroundEmptyTile(target,time,_isRotate)
end

function RemoveWaterBox(width,height)
	local _height = height or 0
	GameSkillFunctions.GetInstance():RemoveWaterBox(width,_height)
end

function CheckInvisibleMonsterState()
	GameSkillFunctions.GetInstance():CheckInvisibleMonsterState()
end

function WarpFloorRequest()
	GameSkillFunctions.GetInstance():WarpFloorRequest()
end

function ForceFloorClearRequest()
	GameSkillFunctions.GetInstance():ForceFloorClearRequest()
end

function PitfallFloorRequest()
	GameSkillFunctions.GetInstance():PitfallFloorRequest()
end

function UpdateFloorBottomBG(bgName,isClippingStartDoor,isClippingGoalDoor)
	local _isClippingStartDoor = isClippingStartDoor or true
	local _isClippingGoalDoor = isClippingGoalDoor or true
	GameSkillFunctions.GetInstance():UpdateFloorBottomBG(bgName,_isClippingStartDoor,_isClippingGoalDoor)
end

function ReloadFloor(floorIDs,monsterGroupID,monsterMax,goldMax,time,shuffleRequest,forceChargePlayer,hideWall)
	local _forceChargePlayer = forceChargePlayer or false
	local _hideWall = hideWall or false
	GameSkillFunctions.GetInstance():ReloadFloor(floorIDs,monsterGroupID,monsterMax,goldMax,time,shuffleRequest,_forceChargePlayer,_hideWall)
end

function SetActiveMapObject(isActive,wallIndex)
	local _wallIndex = wallIndex or 0
	GameSkillFunctions.GetInstance():SetActiveMapObject(isActive,_wallIndex)
end

function GetTargetPosition(target,coordinate,scaleRate,useSpritePosition)
	local _scaleRate = scaleRate or 5.0
	local _useSpritePosition = useSpritePosition or false
	return GameSkillFunctions.GetInstance():GetTargetPosition(target,coordinate,_scaleRate,_useSpritePosition)
end

function GetTargetScale(target)
	return GameSkillFunctions.GetInstance():GetTargetScale(target)
end

function SetTrapState(target,stateName)
	GameSkillFunctions.GetInstance():SetTrapState(target,stateName)
end

function IsAppearTarget(target)
	return GameSkillFunctions.GetInstance():IsAppearTarget(target)
end

function SetAppearTarget(target,isAppear)
	GameSkillFunctions.GetInstance():SetAppearTarget(target,isAppear)
end

function GetOffsetDrawQueue(target)
	return GameSkillFunctions.GetInstance():GetOffsetDrawQueue(target)
end

function CreateItem(itemID,row,col,isCheckSubType)
	local _isCheckSubType = isCheckSubType or false
	GameSkillFunctions.GetInstance():CreateItem(itemID,row,col,_isCheckSubType)
end

function StealPlayerItem(caller,rate,itemID)
	local _itemID = itemID or nil
	GameSkillFunctions.GetInstance():StealPlayerItem(caller,rate,_itemID)
end

function StealPlayerGold(caller,rate,stealGoldMin,stealGoldMax)
	GameSkillFunctions.GetInstance():StealPlayerGold(caller,rate,stealGoldMin,stealGoldMax)
end

function AddSkillBonusParam(target,key,value)
	GameSkillFunctions.GetInstance():AddSkillBonusParam(target,key,value)
end

function ResetDropInfo(target)
	GameSkillFunctions.GetInstance():ResetDropInfo(target)
end

function SetResuscitationInfo(target,hp,rate,count,text)
	GameSkillFunctions.GetInstance():SetResuscitationInfo(target,hp,rate,count,text)
end

function ShowPakoWindow(recoveryCount,isPurchased)
	GameSkillFunctions.GetInstance():ShowPakoWindow(recoveryCount,isPurchased)
end

function ShowMessageDialog(text,delay,addText)
	local _delay = delay or 0.0
	local _addText = addText or "1"
	GameSkillFunctions.GetInstance():ShowMessageDialog(text, _delay, _addText)
end

function ShowSkillName(caller,time,offsetY)
	local _time = time or 0.0
	local _offsetY = offsetY or 0.0
	GameSkillFunctions.GetInstance():ShowSkillName(caller,_time,_offsetY)
end

function ShowSmallMessageWindow(text,caller,time,canOverlap,offsetY)
	local _time = time or 0.0
	local _canOverlap = canOverlap or false
	local _offsetY = offsetY or 0.0
	GameSkillFunctions.GetInstance():ShowSmallMessageWindow(text,caller,_time,_canOverlap,_offsetY)
end

function HideSmallMessageWindow(caller)
	GameSkillFunctions.GetInstance():HideSmallMessageWindow(caller)
end

function ShowDisableSkillDescriptionDialog(text,show)
	GameSkillFunctions.GetInstance():ShowDisableSkillDescriptionDialog(text,show)
end

function SetCounterSkillDialogText(skillID,text)
	GameSkillFunctions.GetInstance():SetCounterSkillDialogText(skillID,text)
end

function SetChallengeMissionResult(result)
	GameSkillFunctions.GetInstance():SetChallengeMissionResult(result)
end

function ShowMultiSelectWindow(text,param)
	GameSkillFunctions.GetInstance():ShowMultiSelectWindow(text,param)
end

function GetMultiSelectWindowIndex()
	return GameSkillFunctions.GetInstance():GetMultiSelectWindowIndex()
end

function AddPlayerGold(gold,time)
	GameSkillFunctions.GetInstance():AddPlayerGold(gold,time)
end

function IsExistTargetLevelMonster(level,includeInvisibleMonster)
	return GameSkillFunctions.GetInstance():IsExistTargetLevelMonster(level,includeInvisibleMonster)
end

function AddLevel(caller,target,range,level,isResetHP)
	GameSkillFunctions.GetInstance():AddLevel(caller,target,range,level,isResetHP)
end

function GetPlayerWalkCount()
	return GameSkillFunctions.GetInstance():GetPlayerWalkCount()
end

function GetPlayerGold()
	return GameSkillFunctions.GetInstance():GetPlayerGold()
end

function FindNeighborMonster(caller,monsterID,fuzzySearch,isPerforate,includeInvisible)
	return GameSkillFunctions.GetInstance():FindNeighborMonster(caller,monsterID,fuzzySearch,isPerforate,includeInvisible)
end

function IsExistNeighborMonster(caller,monsterID,fuzzySearch,isPerforate,includeInvisible)
	return GameSkillFunctions.GetInstance():IsExistNeighborMonster(caller,monsterID,fuzzySearch,isPerforate,includeInvisible)
end

function ExchangeTargetMonster(caller,target,time)
	GameSkillFunctions.GetInstance():ExchangeTargetMonster(caller,target,time)
end

function AddUniqueDataDictionaryIntValue(target,key,val)
	GameSkillFunctions.GetInstance():AddUniqueDataDictionaryIntValue(target,key,val)
end

function GetUniqueDataDictionaryIntValue(target,key)
	return GameSkillFunctions.GetInstance():GetUniqueDataDictionaryIntValue(target,key)
end

function AddUniqueDataDictionaryFloatValue(target,key,val)
	GameSkillFunctions.GetInstance():AddUniqueDataDictionaryFloatValue(target,key,val)
end

function GetUniqueDataDictionaryFloatValue(target,key)
	return GameSkillFunctions.GetInstance():GetUniqueDataDictionaryFloatValue(target,key)
end

function AddUniqueDataDictionaryBoolValue(target,key,val)
	GameSkillFunctions.GetInstance():AddUniqueDataDictionaryBoolValue(target,key,val)
end

function GetUniqueDataDictionaryBoolValue(target,key)
	return GameSkillFunctions.GetInstance():GetUniqueDataDictionaryBoolValue(target,key)
end

function AddUniqueDataDictionaryStringValue(target,key,val)
	GameSkillFunctions.GetInstance():AddUniqueDataDictionaryStringValue(target,key,val)
end

function GetUniqueDataDictionaryStringValue(target,key)
	return GameSkillFunctions.GetInstance():GetUniqueDataDictionaryStringValue(target,key)
end

function CalculateQuizID(groupID)
	return GameSkillFunctions.GetInstance():CalculateQuizID(groupID)
end

function ShowQuizDialog(quizID, correctAddText, incorrectAddTextA, incorrectAddTextB)
	local _correctAddText = correctAddText or nil
	local _incorrectAddTextA = incorrectAddTextA or nil
	local _incorrectAddTextB = incorrectAddTextB or nil
	GameSkillFunctions.GetInstance():ShowQuizDialog(quizID, _correctAddText, _incorrectAddTextA, _incorrectAddTextB)
end

function IsSelectCorrectAnswer()
	return GameSkillFunctions.GetInstance():IsSelectCorrectAnswer()
end

function RandomRangeIntValue(from, to)
	return GameSkillFunctions.GetInstance():RandomRangeIntValue(from, to)
end

function RandomRangeFloatValue(from, to)
	return GameSkillFunctions.GetInstance():RandomRangeFloatValue(from, to)
end

function IsCompleteGrowUp(target)
	return GameSkillFunctions.GetInstance():IsCompleteGrowUp(target)
end

function GetTargetLevelMonsterCount(level, includeInvisibleMonster)
	return GameSkillFunctions.GetInstance():GetTargetLevelMonsterCount(level, includeInvisibleMonster, false)
end

function GetAttackAnimationTime(target)
	return GameSkillFunctions.GetInstance():GetAttackAnimationTime(target)
end

function CreateMonsterEmptyTile(monsterID)
	return GameSkillFunctions.GetInstance():CreateMonsterEmptyTile(monsterID)
end

function GetTileSubTypeAtTarget(target)
	return GameSkillFunctions.GetInstance():GetTileSubTypeAtTarget(target)
end

function IsTargetObstacle(target)
	return GameSkillFunctions.GetInstance():IsTargetObstacle(target)
end

function IsWeakSkillTag(target, tag)
	return GameSkillFunctions.GetInstance():IsWeakSkillTag(target, tag)
end

function GetAttackDirection(caller, target)
	return GameSkillFunctions.GetInstance():GetAttackDirection(caller, target)
end

function PlayParabolaCurrentPositionAnimation(target, x, y, h, time, isReferringDistance, type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayParabolaCurrentPositionAnimation(target, x, y, h, time, isReferringDistance, _type)
end

function PlayBounceAnimation(target, h, time)
	GameSkillFunctions.GetInstance():PlayBounceAnimation(target, h, time)
end

function CreateSkipDoor(range, prefName, animName, skipFloorCount, createInterval, openInterval)
	GameSkillFunctions.GetInstance():CreateSkipDoor(range, prefName, animName, skipFloorCount, createInterval, openInterval)
end

function IsEquipedContents(contentsInfo, category)
	return GameSkillFunctions.GetInstance():IsEquipedContents(contentsInfo, category)
end

function ResetBattleInfo(target, category)
	GameSkillFunctions.GetInstance():ResetBattleInfo(target, category)
end

function PlayParabolaCurrentPositionAnimationWithRenderQ(target, x, y, h, time, isReferringDistance, renderQueue, type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayParabolaCurrentPositionAnimationWithRenderQ(target, x, y, h, time, isReferringDistance, renderQueue, _type)
end

function IsExistFloorEmptyTileWithIgnoreSubType(subType, isCheckWater)
	local _isCheckWater = isCheckWater or false
	return GameSkillFunctions.GetInstance():IsExistFloorEmptyTileWithIgnoreSubType(subType, _isCheckWater)
end

function CreateMonsterEmptyTileWithIgnoreSubType(monsterID, subType)
	return GameSkillFunctions.GetInstance():CreateMonsterEmptyTileWithIgnoreSubType(monsterID, subType)
end

function PlayEffectWithAddRenderQ(prefName, animName, addRenderQueue, x, y, direction)
	local _x = x or 0
	local _y = y or 0
	local _direction = direction or nil
	GameSkillFunctions.GetInstance():PlayEffectWithAddRenderQ(prefName, animName, addRenderQueue, _x, _y, _direction)
end

function PlaySingleTargetEffectWithAddRenderQ(target, prefName, animName, addRenderQueue, range, layer, targetTypeString, caller, reuseFlyEffectTarget)
	local _range = range or nil
	local _layer = layer or "Top"
	local _targetTypeString = targetTypeString or "All"
	local _caller = caller or nil
	local _reuseFlyEffectTarget = reuseFlyEffectTarget or nil
	GameSkillFunctions.GetInstance():PlaySingleTargetEffectWithAddRenderQ(target, prefName, animName, addRenderQueue, _range, _layer, _targetTypeString, _caller, _reuseFlyEffectTarget)
end

function ChangeContents(currentFloorMonsterID, contentsID, isCheckSubType, isPlayDropAnimation)
	return GameSkillFunctions.GetInstance():ChangeContents(currentFloorMonsterID, contentsID, isCheckSubType, isPlayDropAnimation)
end

function IsForceStartTimeCount()
	return GameSkillFunctions.GetInstance():IsForceStartTimeCount()
end

function SetForceStartTimeCount(val)
	GameSkillFunctions.GetInstance():SetForceStartTimeCount(val)
end

function FindNeighborMonsterWithDirection(caller, monsterID, fuzzySearch, isPerforate, includeInvisible, direction)
	return GameSkillFunctions.GetInstance():FindNeighborMonsterWithDirection(caller, monsterID, fuzzySearch, isPerforate, includeInvisible, direction)
end

function IsExistNeighborMonsterWithDirection(caller, monsterID, fuzzySearch, isPerforate, includeInvisible, direction)
	return GameSkillFunctions.GetInstance():IsExistNeighborMonsterWithDirection(caller, monsterID, fuzzySearch, isPerforate, includeInvisible, direction)
end

function PlayReuseEffect(key, prefName, animName, addRenderQueue, x, y, layer, direction)
	local _x = x or 0
	local _y = y or 0
	local _layer = layer or "Top"
	local _direction = direction or nil
	GameSkillFunctions.GetInstance():PlayReuseEffect(key, prefName, animName, addRenderQueue, _x, _y, _layer, _direction)
end

function PlaySingleTargetReuseEffect(key, target, prefName, animName, addRenderQueue, range, layer, targetTypeString, caller)
	local _range = range or nil
	local _layer = layer or "Top"
	local _targetTypeString = targetTypeString or "All"
	local _caller = caller or nil
	GameSkillFunctions.GetInstance():PlaySingleTargetReuseEffect(key, target, prefName, animName, addRenderQueue, _range, _layer, _targetTypeString, _caller)
end

function RemoveReuseEffect(key, fuzzySearch)
	GameSkillFunctions.GetInstance():RemoveReuseEffect(key, fuzzySearch)
end

function GetDropInfoUseCount(target)
	return GameSkillFunctions.GetInstance():GetDropInfoUseCount(target)
end

function IsBrokenDropItem(target)
	return GameSkillFunctions.GetInstance():IsBrokenDropItem(target)
end

function SetDropInfo(target, typeStr, objectID, useCount)
	local _useCount = useCount or 0
	GameSkillFunctions.GetInstance():SetDropInfo(target, typeStr, objectID, _useCount)
end

function GetEventFlagIntValueContainsDungeonStack(key)
	return GameSkillFunctions.GetInstance():GetEventFlagIntValueContainsDungeonStack(key)
end

function GetEventFlagFloatValueContainsDungeonStack(key)
	return GameSkillFunctions.GetInstance():GetEventFlagFloatValueContainsDungeonStack(key)
end

function GetEventFlagBoolValueContainsDungeonStack(key)
	return GameSkillFunctions.GetInstance():GetEventFlagBoolValueContainsDungeonStack(key)
end

function GetEventFlagStringValueContainsDungeonStack(key)
	return GameSkillFunctions.GetInstance():GetEventFlagStringValueContainsDungeonStack(key)
end

function SetStackEventFlagInfoIntValue(key, val, targetRewardName)
	GameSkillFunctions.GetInstance():SetStackEventFlagInfoIntValue(key, val, targetRewardName)
end

function SetStackEventFlagInfoFloatValue(key, val, targetRewardName)
	GameSkillFunctions.GetInstance():SetStackEventFlagInfoFloatValue(key, val, targetRewardName)
end

function SetStackEventFlagInfoBoolValue(key, val, targetRewardName)
	GameSkillFunctions.GetInstance():SetStackEventFlagInfoBoolValue(key, val, targetRewardName)
end

function SetStackEventFlagInfoStringValue(key, val, targetRewardName)
	GameSkillFunctions.GetInstance():SetStackEventFlagInfoStringValue(key, val, targetRewardName)
end

function RemoveMonsterLeaveDropContents(mID)
	GameSkillFunctions.GetInstance():RemoveMonsterLeaveDropContents(mID)
end

function HideGameUI()
	GameSkillFunctions.GetInstance():HideGameUI()
end

function RedisplayGameUI()
	GameSkillFunctions.GetInstance():RedisplayGameUI()
end

function GetCurrentFloorTheme()
	return GameSkillFunctions.GetInstance():GetCurrentFloorTheme()
end

function AddCustomPermanencePhaseChangeOriginalEffect(caller, target, phaseName, range, value, valueBlur, probability, effectPrefName, effectAnimName)
	return GameSkillFunctions.GetInstance():AddCustomPermanencePhaseChangeOriginalEffect(caller, target, phaseName, range, value, valueBlur, probability, effectPrefName, effectAnimName)
end

function GetNextTileType()
	return GameSkillFunctions.GetInstance():GetNextTileType()
end

function SetMoveAfterActionName(actionName)
	GameSkillFunctions.GetInstance():SetMoveAfterActionName(actionName)
end

function SetMoveAnimationInfo(animationInfo)
	GameSkillFunctions.GetInstance():SetMoveAnimationInfo(animationInfo)
end

function GetEmptyTileIndexWithDirection(caller, direction, ignoreSubType, isContainsMovedTile)
	return GameSkillFunctions.GetInstance():GetEmptyTileIndexWithDirection(caller, direction, ignoreSubType, isContainsMovedTile)
end

function IsExistEmptyTileWithDirection(caller, direction, ignoreSubType, isContainsMovedTile)
	return GameSkillFunctions.GetInstance():IsExistEmptyTileWithDirection(caller, direction, ignoreSubType, isContainsMovedTile)
end

function GetFloorMonsterIDList(findID)
	return GameSkillFunctions.GetInstance():GetFloorMonsterIDList(findID)
end

function DelayPlaySingleSE(name, delay)
	GameSkillFunctions.GetInstance():DelayPlaySingleSE(name, delay)
end

function AddCustomPhaseChangeWithOriginalEffect(caller,target,phaseName,range,turn,value,valueBlur,probability,isPermanence,recovery,effectPrefName,effectAnimName)
	return GameSkillFunctions.GetInstance():AddCustomPhaseChangeWithOriginalEffect(caller,target,phaseName,range,turn,value,valueBlur,probability,isPermanence,recovery,effectPrefName,effectAnimName)
end

function IsEmptyTile(x, y, isCheckWater, subType)
	local _isCheckWater = isCheckWater or true
	return GameSkillFunctions.GetInstance():IsEmptyTile(x, y, _isCheckWater, subType)
end

function CreateItemWithOption(itemID,row,col,isCheckSubType,isPlayDropAnimation,dropGold,useCount)
	local _isCheckSubType = isCheckSubType or false
	local _isPlayDropAnimation = isPlayDropAnimation or false
	local _dropGold = dropGold or -1
	local _useCount = useCount or 0
	GameSkillFunctions.GetInstance():CreateItemWithOption(itemID,row,col,_isCheckSubType,_isPlayDropAnimation,_dropGold,_useCount)
end

function IsContainsAttackResultInPlayerAttack(attackResultName)
	return GameSkillFunctions.GetInstance():IsContainsAttackResultInPlayerAttack(attackResultName)
end

function UpgradeCurrentFloorDropItem()
	GameSkillFunctions.GetInstance():UpgradeCurrentFloorDropItem()
end

function IsLuckySpellMode()
	return GameSkillFunctions.GetInstance():IsLuckySpellMode()
end

function GetAllFloorMonsterIDList(includeObstacle,includeInvisibleMonster,ignoreSubType)
	local _ignoreSubType = ignoreSubType or nil
	return GameSkillFunctions.GetInstance():GetAllFloorMonsterIDList(includeObstacle,includeInvisibleMonster,_ignoreSubType)
end

function GetFloorMonsterIDListByType(typeStrings,includeInvisibleMonster,ignoreSubType)
	local _ignoreSubType = ignoreSubType or nil
	return GameSkillFunctions.GetInstance():GetFloorMonsterIDListByType(typeStrings,includeInvisibleMonster,_ignoreSubType)
end

function SelectFloorMonsterIDByIncludeMonsterID(floorMonsterIDs,includeMonsterIDs,ignoreSubType)
	local _includeMonsterIDs = includeMonsterIDs or nil
	local _ignoreSubType = ignoreSubType or nil
	return GameSkillFunctions.GetInstance():SelectFloorMonsterIDByIncludeMonsterID(floorMonsterIDs,_includeMonsterIDs,_ignoreSubType)
end

function SelectFloorMonsterIDByExcludeMonsterID(floorMonsterIDs,excludeMonsterIDs,ignoreSubType)
	local _ignoreSubType = ignoreSubType or nil
	return GameSkillFunctions.GetInstance():SelectFloorMonsterIDByExcludeMonsterID(floorMonsterIDs,excludeMonsterIDs,_ignoreSubType)
end

function PlayMoveToEffectAnimationIgnoreDistance(caller,target,prefName,animName,time,delay,darknessCircleRange,removeDelayCircleTime,easeType,addRenderQueue)
	local _time = time or 0.0
	local _delay = delay or 0.0
	local _darknessCircleRange = darknessCircleRange or 0.0
	local _removeDelayCircleTime = removeDelayCircleTime or 0.0
	local _easeType = easeType or "easeInCubic"
	local _addRenderQueue = addRenderQueue or 0
	GameSkillFunctions.GetInstance():PlayMoveToEffectAnimationIgnoreDistance(caller,target,prefName,animName,_time,_delay,_darknessCircleRange,_removeDelayCircleTime,_easeType,_addRenderQueue)
end

function IsExistMonsterWithIgnoreSubType(ignoreSubType,includeObstacle,includeInvisibleMonster)
	local _includeInvisibleMonster = includeInvisibleMonster or false
	local _includeObstacle = includeObstacle or false
	return GameSkillFunctions.GetInstance():IsExistMonsterWithIgnoreSubType(ignoreSubType,_includeObstacle,_includeInvisibleMonster)
end

function SetCurrentHP(target, hp)
	GameSkillFunctions.GetInstance():SetCurrentHP(target, hp)
end

function PlayHomerunAnimation(caller, target, time, renderQueue, type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayHomerunAnimation(caller, target, time, renderQueue, _type)
end

function CreateTrapAroundEmptyTile(target, trapID, isIncludeCross)
	local _isIncludeCross = isIncludeCross or false
	return GameSkillFunctions.GetInstance():CreateTrapAroundEmptyTile(target, trapID, _isIncludeCross)
end

function PlayMoveToCurrentPositionAnimationForTrap(target,x,y,time,type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayMoveToCurrentPositionAnimationForTrap(target,x,y,time,_type)
end

function IsExistAroundEmptyTileIncludeCross(target)
	return GameSkillFunctions.GetInstance():IsExistAroundEmptyTileIncludeCross(target)
end

function IsEnableHomerun(caller)
	return GameSkillFunctions.GetInstance():IsEnableHomerun(caller)
end

function GetLineTargets(index,isRowMode,includeObstacle,includeInvisible)
	local _includeObstacle = includeObstacle or true
	local _includeInvisible = includeInvisible or false
	return GameSkillFunctions.GetInstance():GetLineTargets(index,isRowMode,_includeObstacle,_includeInvisible)
end

function GetTargetLevelMonsterCountExcludeObstacle(level,includeInvisibleMonster)
	return GameSkillFunctions.GetInstance():GetTargetLevelMonsterCountExcludeObstacle(level,includeInvisibleMonster)
end

function GetRandomMonster(includeInvisibleMonster,includeObstacle,excludeFloorMonsterIDs)
	local _excludeFloorMonsterIDs = excludeFloorMonsterIDs or ""
	return GameSkillFunctions.GetInstance():GetRandomMonster(includeInvisibleMonster,includeObstacle,_excludeFloorMonsterIDs)
end

function HideHPBar(target)
	GameSkillFunctions.GetInstance():HideHPBar(target)
end

function IsForceBossDropItem(target)
	return GameSkillFunctions.GetInstance():IsForceBossDropItem(target)
end

function SetForceBossDropItem(target, isForceBossDrop)
	GameSkillFunctions.GetInstance():SetForceBossDropItem(target, isForceBossDrop)
end

function ShowHPBar(target)
	GameSkillFunctions.GetInstance():ShowHPBar(target)
end

function PlayBGM(bgmName, fadeTime)
	local _fadeTime = fadeTime or 0.0
	GameSkillFunctions.GetInstance():PlayBGM(bgmName, _fadeTime)
end

function StopBGM(fadeTime)
	local _fadeTime = fadeTime or 0.0
	GameSkillFunctions.GetInstance():StopBGM(_fadeTime)
end

function PauseBGM(fadeTime)
	local _fadeTime = fadeTime or 0.0
	GameSkillFunctions.GetInstance():PauseBGM(_fadeTime)
end

function ResumeBGM(fadeTime)
	local _fadeTime = fadeTime or 0.0
	GameSkillFunctions.GetInstance():ResumeBGM(_fadeTime)
end

function HasMatchEquipmentID(matchEquipmentIDs)
	return GameSkillFunctions.GetInstance():HasMatchEquipmentID(matchEquipmentIDs)
end

function GetNextTileMonster(nextCount, includeInvisibleMonster, includeObstacle)
	local _nextCount = nextCount or 1
	local _includeInvisibleMonster = includeInvisibleMonster or false
	local _includeObstacle = includeObstacle or false
	return GameSkillFunctions.GetInstance():GetNextTileMonster(_nextCount, _includeInvisibleMonster, _includeObstacle)
end

function IsExistNextTileMonster(nextCount, includeInvisibleMonster, includeObstacle)
	local _nextCount = nextCount or 1
	local _includeInvisibleMonster = includeInvisibleMonster or false
	local _includeObstacle = includeObstacle or false
	return GameSkillFunctions.GetInstance():IsExistNextTileMonster(_nextCount, _includeInvisibleMonster, _includeObstacle)
end

function GetCurrentDungeonID()
	return GameSkillFunctions.GetInstance():GetCurrentDungeonID()
end

function OverwriteBGMPitch(pitch)
	GameSkillFunctions.GetInstance():OverwriteBGMPitch(pitch)
end

function GetMonsterID(target)
	return GameSkillFunctions.GetInstance():GetMonsterID(target)
end

function CreatePrefabObjectSubParts(path,time,target,subParts,direction,useUICamera,range,ignoreObstacle)
	local _direction = direction or ""
	local _useUICamera = useUICamera or false
	local _range = range or nil
	local _ignoreObstacle = ignoreObstacle or false
	GameSkillFunctions.GetInstance():CreatePrefabObjectSubParts(path,time,target,subParts,_direction,_useUICamera,_range,_ignoreObstacle)
end

function PlayAroundWorldAnimation(target, animationTime, intervalTime, renderQueue, type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayAroundWorldAnimation(target, animationTime, intervalTime, renderQueue, _type)
end

function MoveToAroundEmptyTileWithAnimation(target, time, animationPrefix)
	return GameSkillFunctions.GetInstance():MoveToAroundEmptyTileWithAnimation(target, time, animationPrefix)
end

function GetTileDesignID(row, col)
	return GameSkillFunctions.GetInstance():GetTileDesignID(row, col)
end

function IsExistTileDesign(designID)
	return GameSkillFunctions.GetInstance():IsExistTileDesign(designID)
end

function MoveToEmptyTileImmediate(target, isCheckWater)
	local _isCheckWater = isCheckWater or false
	GameSkillFunctions.GetInstance():MoveToEmptyTileImmediate(target, isCheckWater)
end

function MoveToTileDesignImmediate(target, designID)
	GameSkillFunctions.GetInstance():MoveToTileDesignImmediate(target, designID)
end

function PlayMoveToEffectAnimationByPosition(fromX,fromY,toX,toY,prefName,animName,time,delay,darknessCircleRange,removeDelayCircleTime,easeType,addRenderQueue)
	local _time = time or 0.0
	local _delay = delay or 0.0
	local _darknessCircleRange = darknessCircleRange or 0.0
	local _removeDelayCircleTime = removeDelayCircleTime or 0.0
	local _easeType = easeType or "easeInCubic"
	local _addRenderQueue = addRenderQueue or 0
	GameSkillFunctions.GetInstance():PlayMoveToEffectAnimationByPosition(fromX,fromY,toX,toY,prefName,animName,_time,_delay,_darknessCircleRange,_removeDelayCircleTime,_easeType,_addRenderQueue)
end

function GetCurrentFloorID()
	return GameSkillFunctions.GetInstance():GetCurrentFloorID()
end

function IsWeakElement(target, elementStr)
	return GameSkillFunctions.GetInstance():IsWeakElement(target, elementStr)
end

function GetTargetMasterID(target)
	return GameSkillFunctions.GetInstance():GetTargetMasterID(target)
end

function ContainsMasterID(target, id)
	return GameSkillFunctions.GetInstance():ContainsMasterID(target, id)
end

function AddSpecialDoorView(row, col, designID, specialFloorID, subType)
	local _subType = subType or nil
	GameSkillFunctions.GetInstance():AddSpecialDoorView(row, col, designID, specialFloorID, _subType)
end

function IsExistSpecialDoorView(specialFloorID)
	return GameSkillFunctions.GetInstance():IsExistSpecialDoorView(specialFloorID)
end

function RemoveAllGoodPhaseChange(target, range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():RemoveAllGoodPhaseChange(target, _range)
end

function HasGoodPhaseChange(target, isContainPermanence)
	local _isContainPermanence = isContainPermanence or false
	return GameSkillFunctions.GetInstance():HasGoodPhaseChange(target, _isContainPermanence)
end

function CreateItemEmptyTileWithOption(itemID,isCheckSubType,isPlayDropAnimation,isTreasure)
	local _isCheckSubType = isCheckSubType or false
	local _isPlayDropAnimation = isPlayDropAnimation or false
	local _isTreasure = isTreasure or false
	GameSkillFunctions.GetInstance():CreateItemEmptyTileWithOption(itemID,_isCheckSubType,_isPlayDropAnimation,_isTreasure)
end

function CreateBulletPrefabObject(path,time,caller,target)
	local _target = target or nil
	GameSkillFunctions.GetInstance():CreateBulletPrefabObject(path,time,caller,_target)
end

function RemoveAllPhaseChange(target,range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():RemoveAllPhaseChange(target,_range)
end

function SetEnableCountdownAction(target,isEnable)
	GameSkillFunctions.GetInstance():SetEnableCountdownAction(target,isEnable)
end

function SetInvincibleEffectInfo(target,time,prefName,animName)
	local _time = time or 0
	local _prefName = prefName or nil
	local _animName = animName or nil
	GameSkillFunctions.GetInstance():SetInvincibleEffectInfo(target,_time,_prefName,_animName)
end

function ResetInvincibleEffectInfo(target)
	GameSkillFunctions.GetInstance():ResetInvincibleEffectInfo(target)
end

function GetFloorMonsterIDsByMonsterIDs(targetFloorMonsterIDs)
	return GameSkillFunctions.GetInstance():GetFloorMonsterIDsByMonsterIDs(targetFloorMonsterIDs)
end

function GetAroundTargets(targetFloorMonsterIDs, includeTargetMonster, includeObstacle, includeInvisible, isCross, includePlayer)
	local _includeInvisible = includeInvisible or false
	local _isCross = isCross or false
	local _includePlayer = includePlayer or false
	return GameSkillFunctions.GetInstance():GetAroundTargets(targetFloorMonsterIDs, includeTargetMonster, includeObstacle, _includeInvisible, _isCross, _includePlayer)
end

function SetCharaEffect(target,prefName,animName)
	GameSkillFunctions.GetInstance():SetCharaEffect(target,prefName,animName)
end

function PlayCharaEffect(target,animName,afterAnimName)
	local _afterAnimName = afterAnimName or nil
	GameSkillFunctions.GetInstance():PlayCharaEffect(target,animName,_afterAnimName)
end

function RemoveCharaEffect(target,animName)
	local _animName = animName or nil
	GameSkillFunctions.GetInstance():RemoveCharaEffect(target,animName)
end

function GetTargetMonsterPrefabName(monsterID)
	return GameSkillFunctions.GetInstance():GetTargetMonsterPrefabName(monsterID)
end

function GetDistance(caller, target)
	return GameSkillFunctions.GetInstance():GetDistance(caller, target)
end

function DelaySetActiveSprite(target,active,delay)
	GameSkillFunctions.GetInstance():DelaySetActiveSprite(target,active,delay)
end

function DelayPlaySingleAnim(target,anim,delay)
	GameSkillFunctions.GetInstance():DelayPlaySingleAnim(target,anim,delay)
end

function SelectRandomID(inputIDs, ignoreIDs)
	local _ignoreIDs = ignoreIDs or nil
	return GameSkillFunctions.GetInstance():SelectRandomID(inputIDs, _ignoreIDs)
end

function SelectNearestID(caller, inputIDs, ignoreIDs)
	local _ignoreIDs = ignoreIDs or nil
	return GameSkillFunctions.GetInstance():SelectNearestID(caller, inputIDs, _ignoreIDs)
end

function ReplaceDamageSound(target, soundName)
	GameSkillFunctions.GetInstance():ReplaceDamageSound(target, soundName)
end

function ResetDamageSound(target)
	GameSkillFunctions.GetInstance():ResetDamageSound(target)
end

function GetCurrentFloorCount()
	return GameSkillFunctions.GetInstance():GetCurrentFloorCount()
end

function PlayRotateEffect(target, path, num, rad, speed, subPartsName)
	local _subPartsName = subPartsName or nil
	GameSkillFunctions.GetInstance():PlayRotateEffect(target, path, num, rad, speed, _subPartsName)
end

function FireRotateEffect(target, moveSpeed, fadeTime)
	GameSkillFunctions.GetInstance():FireRotateEffect(target, moveSpeed, fadeTime)
end

function ReleaseRotateEffect(target, fadeTime, minX, maxX, minY, maxY, addY)
	local _minX = minX or nil
	local _maxX = maxX or nil
	local _minY = minY or nil
	local _maxY = maxY or nil
	local _addY = addY or nil
	GameSkillFunctions.GetInstance():ReleaseRotateEffect(target, fadeTime, _minX, _maxX, _minY, _maxY, _addY)
end

function CopyGoodPhaseChange(caller, target, isContainPermanence)
	return GameSkillFunctions.GetInstance():CopyGoodPhaseChange(caller, target, isContainPermanence)
end

function GetDamageInfoOpponent(target)
	return GameSkillFunctions.GetInstance():GetDamageInfoOpponent(target)
end

function UpgradeTargetDropItem(target)
	GameSkillFunctions.GetInstance():UpgradeTargetDropItem(target)
end

function CalcTargetAngle(caller, target, callerOffsetX, callerOffsetY, targetOffsetX, targetOffsetY)
	local _callerOffsetX = callerOffsetX or 0.0
	local _callerOffsetY = callerOffsetY or 0.0
	local _targetOffsetX = targetOffsetX or 0.0
	local _targetOffsetY = targetOffsetY or 0.0
	return GameSkillFunctions.GetInstance():CalcTargetAngle(caller, target, _callerOffsetX, _callerOffsetY, _targetOffsetX, _targetOffsetY)
end

function CreatePrefabObjectWithRotation(path,time,target,angle,subParts,direction,useUICamera,range,ignoreObstacle)
	local _subParts = subParts or nil
	local _direction = direction or ""
	local _useUICamera = useUICamera or false
	local _range = range or nil
	local _ignoreObstacle = ignoreObstacle or false
	GameSkillFunctions.GetInstance():CreatePrefabObjectWithRotation(path,time,target,angle,_subParts,_direction,_useUICamera,_range,_ignoreObstacle)
end

function HasInvalidPhaseChanges(target, phaseChange, containAttach)
	return GameSkillFunctions.GetInstance():HasInvalidPhaseChanges(target, phaseChange, containAttach)
end

function PlayEatAnimation(caller, target, time, renderQueue, type)
	local _type = type or "linear"
	GameSkillFunctions.GetInstance():PlayEatAnimation(caller, target, time, renderQueue, _type)
end

function PlayEatItemIconAnimation(caller)
	GameSkillFunctions.GetInstance():PlayEatItemIconAnimation(caller)
end

function SetBigDamageFontMode(isActive)
	GameSkillFunctions.GetInstance():SetBigDamageFontMode(isActive)
end

function ResetDamageInfoOpponent(target)
	GameSkillFunctions.GetInstance():ResetDamageInfoOpponent(target)
end

function ShowMessageDialogWithVoice(text, actorName, position)
	local _position = position or "bottom"
	GameSkillFunctions.GetInstance():ShowMessageDialogWithVoice(text, actorName, _position)
end

function SetActiveEffect(target, isActive)
	GameSkillFunctions.GetInstance():SetActiveEffect(target, isActive)
end

function IsContainsMissionTag(missonTagInfo, category)
	return GameSkillFunctions.GetInstance():IsContainsMissionTag(missonTagInfo, category)
end

function ShowThiefSatoWindow(highSpecMinSpeed, highSpecMaxSpeed, goldModeSpeedRate, lowSpecMinSpeed, lowSpecMaxSpeed)
	local _lowSpecMinSpeed = lowSpecMinSpeed or 0
	local _lowSpecMaxSpeed = lowSpecMaxSpeed or 0
	GameSkillFunctions.GetInstance():ShowThiefSatoWindow(highSpecMinSpeed, highSpecMaxSpeed, goldModeSpeedRate, _lowSpecMinSpeed, _lowSpecMaxSpeed)
end

function RemoveAllGoodPhaseChange_IgnoreOption(target, ignorePhaseChanges, range)
	local _range = range or nil
	GameSkillFunctions.GetInstance():RemoveAllGoodPhaseChange_IgnoreOption(target, ignorePhaseChanges, _range)
end

function HasGoodPhaseChange_IgnoreOption(target, ignorePhaseChanges, isContainPermanence)
	local _isContainPermanence = isContainPermanence or false
	return GameSkillFunctions.GetInstance():HasGoodPhaseChange_IgnoreOption(target, ignorePhaseChanges, _isContainPermanence)
end

function CopyGoodPhaseChange_IgnoreOption(caller, target, ignorePhaseChanges, isContainPermanence)
	return GameSkillFunctions.GetInstance():CopyGoodPhaseChange_IgnoreOption(caller, target, ignorePhaseChanges, isContainPermanence)
end

function SetDarknessRestTurn(restTurn, seName, bgmName)
	GameSkillFunctions.GetInstance():SetDarknessRestTurn(restTurn, seName, bgmName)
end

function SetFieldEffect(path, index)
	GameSkillFunctions.GetInstance():SetFieldEffect(path, index)
end

function RemoveFieldEffect(index)
	GameSkillFunctions.GetInstance():RemoveFieldEffect(index)
end

function GetInventoryItemCount(itemID)
	return GameSkillFunctions.GetInstance():GetInventoryItemCount(itemID)
end

function RemoveInventoryItem(itemID, isAll)
	GameSkillFunctions.GetInstance():RemoveInventoryItem(itemID, isAll)
end

function CreatePrefabObjectTargetPos(path, time, x, y)
	GameSkillFunctions.GetInstance():CreatePrefabObjectTargetPos(path, time, x, y)
end

function IsContainTagOrTypeInAttackResult(tag, type)
	return GameSkillFunctions.GetInstance():IsContainTagOrTypeInAttackResult(tag, type)
end

function SetDeadEffect(target, path, time, effectTarget)
	local _path = path or nil
	local _time = time or 0.0
	local _effectTarget = effectTarget or nil
	GameSkillFunctions.GetInstance():SetDeadEffect(target, _path, _time, _effectTarget)
end

function SetStayTrapSkillId(skillId)
	GameSkillFunctions.GetInstance():SetStayTrapSkillId(skillId)
end

function SetReplaceSkillDamage(target, skillDamage)
	GameSkillFunctions.GetInstance():SetReplaceSkillDamage(target, skillDamage)
end

function MoveToReuseEffect(key, animName, playTimes, fromX, fromY, toX, toY, time, addRenderQueue, easeType)
	local _addRenderQueue = addRenderQueue or 0
	local _easeType = easeType or "linear"
	GameSkillFunctions.GetInstance():MoveToReuseEffect(key, animName, playTimes, fromX, fromY, toX, toY, time, _addRenderQueue, _easeType)
end

function ResetDamageInfoElement(target)
	GameSkillFunctions.GetInstance():ResetDamageInfoElement(target)
end

function IsBigMonster(target)
	GameSkillFunctions.GetInstance():IsBigMonster(target)
end

function GetBetweenTargets(caller, target, includeObstacle, includeInvisible)
	local _includeInvisible = includeInvisible or false
	return GameSkillFunctions.GetInstance():GetBetweenTargets(caller, target, includeObstacle, _includeInvisible)
end

function GetAroundEmptyTileIndexStr(target, isCheckWall, isCheckWater)
	return GameSkillFunctions.GetInstance():GetAroundEmptyTileIndexStr(target, isCheckWall, isCheckWater)
end

function MoveToTargetTileIndex(target, tileIndexStr, time, isRotate)
	local _isRotate = isRotate or false
	GameSkillFunctions.GetInstance():MoveToTargetTileIndex(target, tileIndexStr, time, _isRotate)
end

function IsAroundTargetTileIndex(target, tileIndexStr, isCheckWall, isCheckWater)
	return GameSkillFunctions.GetInstance():IsAroundTargetTileIndex(target, tileIndexStr, isCheckWall, isCheckWater)
end

function GetLastHealValue(target)
	return GameSkillFunctions.GetInstance():GetLastHealValue(target)
end

function ResetLastHealValue(target)
	GameSkillFunctions.GetInstance():ResetLastHealValue(target)
end

function ResetLastHealValueAllMonster()
	GameSkillFunctions.GetInstance():ResetLastHealValueAllMonster()
end

function SelectRandomTarget(floorMonsterIDs, includeObstacle)
	return GameSkillFunctions.GetInstance():SelectRandomTarget(floorMonsterIDs, includeObstacle)
end

function SetFloorSkill(skillName, initialStepTurn, nextStepTurn)
	GameSkillFunctions.GetInstance():SetFloorSkill(skillName, initialStepTurn, nextStepTurn)
end

function GetTileDesignIndexRow(designID)
	return GameSkillFunctions.GetInstance():GetTileDesignIndexRow(designID)
end

function GetTileDesignIndexColumn(designID)
	return GameSkillFunctions.GetInstance():GetTileDesignIndexColumn(designID)
end

function GetTileDesignPosition(designID, coordinate)
	return GameSkillFunctions.GetInstance():GetTileDesignPosition(designID, coordinate)
end

function AddBeatMonsterHistory(monsterID, count)
	GameSkillFunctions.GetInstance():AddBeatMonsterHistory(monsterID, count)
end
