EnhanceMatrix = {}
EnhanceMatrix["Weapon"] = {}
EnhanceMatrix["Shield"] = {}
EnhanceMatrix["Armor"] = {}
EnhanceMatrix["Helmet"] = {}

--[[
	hp=0,
	atk=0,
	def=0,
	speed=0,
	accuracy=0,
	luck=0,
	guard=0,
	arrowGuard=0,
	breakrate=10
]]--

EnhanceMatrix["Weapon"] = {
	type_weapon_1 = {
		level_1 = {atk=1},
		level_2 = {atk=2},
		level_3 = {atk=3},
		level_4 = {atk=4},
		level_5 = {atk=5},
		level_6 = {atk=6},
		level_7 = {atk=7},
		level_8 = {atk=8},
		level_9 = {atk=9},
		level_10 = {atk=10},
		level_11 = {atk=11},
		level_12 = {atk=12},
		level_13 = {atk=13},
		level_14 = {atk=14},
		level_15 = {atk=15},
		level_16 = {atk=16},
		level_17 = {atk=17},
		level_18 = {atk=18},
		level_19 = {atk=19},
		level_20 = {atk=20},
		level_21 = {atk=21},
		level_22 = {atk=22},
		level_23 = {atk=23},
		level_24 = {atk=24},
		level_25 = {atk=25}
	}
}

EnhanceMatrix["Shield"] = {
	type_shield_1 = {
		level_1  = {def=1,guard=0},
		level_2  = {def=1,guard=1},
		level_3  = {def=1,guard=1},
		level_4  = {def=2,guard=1},
		level_5  = {def=2,guard=2},
		level_6  = {def=2,guard=2},
		level_7  = {def=3,guard=3},
		level_8  = {def=3,guard=3},
		level_9  = {def=3,guard=3},
		level_10 = {def=4,guard=3},
		level_11 = {def=4,guard=4},
		level_12 = {def=4,guard=4},
		level_13 = {def=5,guard=4},
		level_14 = {def=5,guard=5},
		level_15 = {def=6,guard=5},
		level_16 = {def=6,guard=5},
		level_17 = {def=6,guard=6},
		level_18 = {def=6,guard=6},
		level_19 = {def=7,guard=6},
		level_20 = {def=7,guard=7},
		level_21 = {def=7,guard=7},
		level_22 = {def=8,guard=7},
		level_23 = {def=8,guard=8},
		level_24 = {def=8,guard=8},
		level_25 = {def=9,guard=8}
	}
}

EnhanceMatrix["Armor"] = {
	type_armor_1 = {
		level_1  = {def=1},
		level_2  = {def=1},
		level_3  = {def=2},
		level_4  = {def=2},
		level_5  = {def=3},
		level_6  = {def=3},
		level_7  = {def=4},
		level_8  = {def=4},
		level_9  = {def=5},
		level_10 = {def=5},
		level_11 = {def=6},
		level_12 = {def=6},
		level_13 = {def=7},
		level_14 = {def=7},
		level_15 = {def=8},
		level_16 = {def=8},
		level_17 = {def=9},
		level_18 = {def=9},
		level_19 = {def=10},
		level_20 = {def=11},
		level_21 = {def=11},
		level_22 = {def=11},
		level_23 = {def=12},
		level_24 = {def=12},
		level_25 = {def=13}
	}
}

EnhanceMatrix["Helmet"] = {
	type_helmet_1 = {
		level_1 = {def=1},
		level_2 = {def=1},
		level_3 = {def=2},
		level_4 = {def=2},
		level_5 = {def=3},
		level_6 = {def=3},
		level_7 = {def=4},
		level_8 = {def=4},
		level_9 = {def=5},
		level_10 ={def=5},
		level_11 ={def=6},
		level_12 ={def=6},
		level_13 ={def=7},
		level_14 ={def=7},
		level_15 ={def=8},
		level_16 ={def=8},
		level_17 ={def=9},
		level_18 ={def=9},
		level_19 ={def=10},
		level_20 ={def=11},
		level_21 ={def=11},
		level_22 ={def=11},
		level_23 ={def=12},
		level_24 ={def=12},
		level_25 ={def=13}
	}
}

--[[
require "Equipment/Enhance_Weapon_000"
require "Equipment/Enhance_Weapon_001"
require "Equipment/Enhance_Weapon_002"
require "Equipment/Enhance_Weapon_003"
require "Equipment/Enhance_Weapon_004"
require "Equipment/Enhance_Weapon_005"
require "Equipment/Enhance_Weapon_006"
require "Equipment/Enhance_Weapon_007"
require "Equipment/Enhance_Weapon_900"
require "Equipment/Enhance_Weapon_First"
require "Equipment/Enhance_Weapon_Material"
require "Equipment/Enhance_Weapon_Material02"
require "Equipment/Enhance_Weapon_Katana"
require "Equipment/Enhance_Weapon_Rapier"
require "Equipment/Enhance_Weapon_HolyRod"
require "Equipment/Enhance_Weapon_Hummer"
require "Equipment/Enhance_Weapon_TwoHandedSword"

require "Equipment/Enhance_Shield_000"
require "Equipment/Enhance_Shield_001"
require "Equipment/Enhance_Shield_002"
require "Equipment/Enhance_Shield_003"
require "Equipment/Enhance_Shield_900"
require "Equipment/Enhance_Shield_First"
require "Equipment/Enhance_Shield_Dokuro"
require "Equipment/Enhance_Shield_Buckler"
require "Equipment/Enhance_Shield_Magic"
require "Equipment/Enhance_Shield_Sleep"
require "Equipment/Enhance_Shield_Poison"

require "Equipment/Enhance_Armor_000"
require "Equipment/Enhance_Armor_001"
require "Equipment/Enhance_Armor_002"
require "Equipment/Enhance_Armor_900"
require "Equipment/Enhance_Armor_First"
require "Equipment/Enhance_Armor_Chu"
require "Equipment/Enhance_Armor_Sanzoku"
require "Equipment/Enhance_Armor_Samurai"
require "Equipment/Enhance_Armor_Kariudo"

require "Equipment/Enhance_Helmet_000"
require "Equipment/Enhance_Helmet_001"
require "Equipment/Enhance_Helmet_002"
require "Equipment/Enhance_Helmet_900"
require "Equipment/Enhance_Helmet_Chu"
require "Equipment/Enhance_Helmet_First"
require "Equipment/Enhance_Helmet_Sanzoku"
require "Equipment/Enhance_Helmet_Samurai"
require "Equipment/Enhance_Helmet_Kariudo"
]]--