--[[

]]--

LANGUAGE = "jp"
LOCALE = "JP"

App = App or {}

--[[
require "Flag"
require "Utils"
]]--
--require "StateMachine"
Localizedstring = {}
--require "Localizedstring"
--require "EventLocalizedstring"

--[[
require "Levels"

require "Event/EventSequenceUtils"
require "Event/EventSequences"

--require "ScenarioUtils"
require "Title"
require "Home"
require "Enhance"
require "Evolution"

require "RankingTable"
require "ShopTable"
require "CommonData"
require "Player"
require "MenuLevelTable"
require "MenuFunctionUnlockTable"
require "YamadaMenuUnlockTable"

require "ItemSortKey"
require "ItemTable"
require "TreasureContentsTable"

require "Equipment/EquipmentsTable"
require "Equipment/EnhanceMatrix"
require "Equipment/EnhanceLevelTable"

require "Dungeon/DungeonTable"
require "Dungeon/DungeonTrapTable"

require "Monster/MonstersTable"
require "Monster/MonsterGroupTable"
require "Monster/MonsterAITable"
require "Monster/MonstersTable_Sub"

require "PhaseChangeTable"
require "ElementTable"
require "SkillTable"
]]--

function App:stateWillEnter()
  	print("current state" .. getStatePath(_G))
--	changeSubState( self, "Title" )
end

changeSubState(_G, "App")

function App:OnEnterToTitle()
	changeSubState( App, "Title" )
end

function App:OnEnterToHome(from,exp,level,yamadaFunctions)
	changeSubState( App, "Home" )
	callEvent("OnEnterToHome", from,exp,level,yamadaFunctions)
end

function App:OnEnterToLevel(stageName)
	print("App:OnEnterToLevel " .. tostring(stageName))
	changeSubState( App, "Levels")
	callEvent("OnEnterToLevel", stageName)
end